/*
RPI ECSE 4750 - Homework 3
Jacob S. Thomas - thomaj17@rpi.edu
Last Modified: 09/25/19
*/

var gl;
var Vshader_program;

// global vars for slider handles
var sliderX;
var sliderY;
var sliderZ;

// global vars for slider values
var xRot_degrees;
var yRot_degrees;
var zRot_degrees;

window.onload = function init()
{
    // Initialize WebGL
    var canvas = document.getElementById( "gl-canvas" );
    
    gl = WebGLUtils.setupWebGL( canvas );
    if ( !gl ) { alert( "WebGL isn't available" ); }

    //
    //  Configure WebGL
    //
    gl.viewport( 0, 0, canvas.width, canvas.height );
    gl.clearColor( 0.0, 0.0, 0.0, 1.0 );
    gl.enable(gl.DEPTH_TEST);

    // Initialize the slider globals
    sliderX = document.getElementById("sliderX");
    sliderY = document.getElementById("sliderY");
    sliderZ = document.getElementById("sliderZ");

    xRot_degrees = sliderX.value;
    yRot_degrees = sliderY.value;
    zRot_degrees = sliderZ.value;
    
    //  Load shaders and initialize attribute buffers
    Vshader_program = initShaders( gl, "vertex-shader", "fragment-shader" );
    gl.useProgram( Vshader_program );
    
    // Load the data into the GPU
    var bufferId = gl.createBuffer();
    gl.bindBuffer( gl.ARRAY_BUFFER, bufferId);
    gl.bufferData( gl.ARRAY_BUFFER, flatten(vertices), gl.STATIC_DRAW );

    // Associate out shader variables with our data buffer
    var vPosition = gl.getAttribLocation( Vshader_program, "vPosition" );
    gl.vertexAttribPointer( vPosition, 3, gl.FLOAT, false, 0, 0 );
    gl.enableVertexAttribArray( vPosition );

    // Event Handlers
    sliderX.oninput = function(event) { xRot_degrees = event.target.value; render(Vshader_program);};
    sliderY.oninput = function(event) { yRot_degrees = event.target.value; render(Vshader_program);};
    sliderZ.oninput = function(event) { zRot_degrees = event.target.value; render(Vshader_program);};

    render();
};

// Reset Function for button
function reset() {
    sliderX.value = 180;
    xRot_degrees = 180;
    sliderY.value = 180;
    yRot_degrees = 180;
    sliderZ.value = 180;
    zRot_degrees = 180;
    render();
}

function render() {
    gl.clear( gl.COLOR_BUFFER_BIT | gl.DEPTH_BUFFER_BIT);

    //  Get Location of Matrices.
    var location_rotx = gl.getUniformLocation(Vshader_program, "Rot_x");
    var location_roty = gl.getUniformLocation(Vshader_program, "Rot_y");
    var location_rotz = gl.getUniformLocation(Vshader_program, "Rot_z");

    gl.uniformMatrix4fv(location_rotx, false, m_rotX(xRot_degrees));
    gl.uniformMatrix4fv(location_roty, false, m_rotY(yRot_degrees));
    gl.uniformMatrix4fv(location_rotz, false, m_rotZ(zRot_degrees));

    // Change primitive to GL_TRIANGLES for ease of use while packing vertices
    gl.drawArrays( gl.TRIANGLES, 0, count/3);
}

function m_rotX(angle_degree) {
    // Convert to radians, use sin and cos.
    var c = Math.cos((Math.PI / 180) * angle_degree);
    var s = Math.sin((Math.PI / 180) * angle_degree);

    return [
        1, 0, 0, 0,
        0, c, s, 0,
        0, -s, c, 0,
        0, 0, 0, 1,
    ];
}

function m_rotY(angle_degree) {
    // Convert to radians, use sin and cos.
    var c = Math.cos((Math.PI / 180) * angle_degree);
    var s = Math.sin((Math.PI / 180) * angle_degree);

    return [
        c, 0, -s, 0,
        0, 1, 0, 0,
        s, 0, c, 0,
        0, 0, 0, 1,
    ];
}

function m_rotZ(angle_degree) {
    // Convert to radians, use sin and cos.
    var c = Math.cos((Math.PI / 180) * angle_degree);
    var s = Math.sin((Math.PI / 180) * angle_degree);

    return [
        c, s, 0, 0,
        -s, c, 0, 0,
        0, 0, 1, 0,
        0, 0, 0, 1,
    ];
}
